Index: doc/FAQ/ChangeLog
===================================================================
--- doc/FAQ/ChangeLog	(revision 6d0a5c0bb9b6cff57ed26cfc50e2914ae6030ab0)
+++ doc/FAQ/ChangeLog	(revision 816539819aafa1b5325202cf5396764ad416a85d)
@@ -1,2 +1,6 @@
+2002-01-18	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: include main.am, require automake-1.5.
+
 2001-01-17	Joel Sherrill <joel@OARcorp.com>
 
Index: doc/FAQ/Makefile.am
===================================================================
--- doc/FAQ/Makefile.am	(revision 6d0a5c0bb9b6cff57ed26cfc50e2914ae6030ab0)
+++ doc/FAQ/Makefile.am	(revision 816539819aafa1b5325202cf5396764ad416a85d)
@@ -7,5 +7,5 @@
 #
 
-AUTOMAKE_OPTIONS = foreign 1.4
+AUTOMAKE_OPTIONS = foreign 1.5
 
 PROJECT = FAQ
@@ -13,4 +13,5 @@
 
 include $(top_srcdir)/project.am
+include $(top_srcdir)/main.am
 
 GENERATED_FILES = basic.texi tools.texi concepts.texi build45.texi bsp.texi \
Index: doc/ada_user/ChangeLog
===================================================================
--- doc/ada_user/ChangeLog	(revision 6d0a5c0bb9b6cff57ed26cfc50e2914ae6030ab0)
+++ doc/ada_user/ChangeLog	(revision 816539819aafa1b5325202cf5396764ad416a85d)
@@ -1,2 +1,6 @@
+2002-01-18	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: include main.am, require automake-1.5.
+
 2001-01-17	Joel Sherrill <joel@OARcorp.com>
 
Index: doc/ada_user/Makefile.am
===================================================================
--- doc/ada_user/Makefile.am	(revision 6d0a5c0bb9b6cff57ed26cfc50e2914ae6030ab0)
+++ doc/ada_user/Makefile.am	(revision 816539819aafa1b5325202cf5396764ad416a85d)
@@ -7,5 +7,5 @@
 #
 
-AUTOMAKE_OPTIONS = foreign 1.4
+AUTOMAKE_OPTIONS = foreign 1.5
 
 PROJECT = ada_user
@@ -13,4 +13,5 @@
 
 include $(top_srcdir)/project.am
+include $(top_srcdir)/main.am
 
 COMMON_FILES = $(top_srcdir)/user/bsp.texi $(top_srcdir)/user/clock.texi \
Index: doc/bsp_howto/ChangeLog
===================================================================
--- doc/bsp_howto/ChangeLog	(revision 6d0a5c0bb9b6cff57ed26cfc50e2914ae6030ab0)
+++ doc/bsp_howto/ChangeLog	(revision 816539819aafa1b5325202cf5396764ad416a85d)
@@ -1,2 +1,6 @@
+2002-01-18	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: include main.am, require automake-1.5.
+
 2001-01-17	Joel Sherrill <joel@OARcorp.com>
 
Index: doc/bsp_howto/Makefile.am
===================================================================
--- doc/bsp_howto/Makefile.am	(revision 6d0a5c0bb9b6cff57ed26cfc50e2914ae6030ab0)
+++ doc/bsp_howto/Makefile.am	(revision 816539819aafa1b5325202cf5396764ad416a85d)
@@ -7,5 +7,5 @@
 #
 
-AUTOMAKE_OPTIONS = foreign 1.4
+AUTOMAKE_OPTIONS = foreign 1.5
 
 PROJECT = bsp_howto
@@ -13,4 +13,5 @@
 
 include $(top_srcdir)/project.am
+include $(top_srcdir)/main.am
 
 GENERATED_FILES = intro.texi target.texi makefiles.texi linkcmds.texi \
Index: doc/develenv/ChangeLog
===================================================================
--- doc/develenv/ChangeLog	(revision 6d0a5c0bb9b6cff57ed26cfc50e2914ae6030ab0)
+++ doc/develenv/ChangeLog	(revision 816539819aafa1b5325202cf5396764ad416a85d)
@@ -1,2 +1,6 @@
+2002-01-18	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: include main.am, require automake-1.5.
+
 2001-01-17	Joel Sherrill <joel@OARcorp.com>
 
Index: doc/develenv/Makefile.am
===================================================================
--- doc/develenv/Makefile.am	(revision 6d0a5c0bb9b6cff57ed26cfc50e2914ae6030ab0)
+++ doc/develenv/Makefile.am	(revision 816539819aafa1b5325202cf5396764ad416a85d)
@@ -7,5 +7,5 @@
 #
 
-AUTOMAKE_OPTIONS = foreign 1.4
+AUTOMAKE_OPTIONS = foreign 1.5
 
 PROJECT = develenv
@@ -13,4 +13,5 @@
 
 include $(top_srcdir)/project.am
+include $(top_srcdir)/main.am
 
 FILES = compile.texi direct.texi intro.texi sample.texi utils.texi
Index: doc/filesystem/ChangeLog
===================================================================
--- doc/filesystem/ChangeLog	(revision 6d0a5c0bb9b6cff57ed26cfc50e2914ae6030ab0)
+++ doc/filesystem/ChangeLog	(revision 816539819aafa1b5325202cf5396764ad416a85d)
@@ -1,2 +1,6 @@
+2002-01-18	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: include main.am, require automake-1.5.
+
 2001-01-17	Joel Sherrill <joel@OARcorp.com>
 
Index: doc/filesystem/Makefile.am
===================================================================
--- doc/filesystem/Makefile.am	(revision 6d0a5c0bb9b6cff57ed26cfc50e2914ae6030ab0)
+++ doc/filesystem/Makefile.am	(revision 816539819aafa1b5325202cf5396764ad416a85d)
@@ -7,5 +7,5 @@
 #
 
-AUTOMAKE_OPTIONS = foreign 1.4
+AUTOMAKE_OPTIONS = foreign 1.5
 
 PROJECT = filesystem
@@ -13,4 +13,5 @@
 
 include $(top_srcdir)/project.am
+include $(top_srcdir)/main.am
 
 BMENU2 += -c
Index: doc/itron3.0/ChangeLog
===================================================================
--- doc/itron3.0/ChangeLog	(revision 6d0a5c0bb9b6cff57ed26cfc50e2914ae6030ab0)
+++ doc/itron3.0/ChangeLog	(revision 816539819aafa1b5325202cf5396764ad416a85d)
@@ -1,2 +1,6 @@
+2002-01-18	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: include main.am, require automake-1.5.
+
 2001-01-17	Joel Sherrill <joel@OARcorp.com>
 
Index: doc/itron3.0/Makefile.am
===================================================================
--- doc/itron3.0/Makefile.am	(revision 6d0a5c0bb9b6cff57ed26cfc50e2914ae6030ab0)
+++ doc/itron3.0/Makefile.am	(revision 816539819aafa1b5325202cf5396764ad416a85d)
@@ -7,5 +7,5 @@
 #
 
-AUTOMAKE_OPTIONS = foreign 1.4
+AUTOMAKE_OPTIONS = foreign 1.5
 
 PROJECT = itron
@@ -13,4 +13,5 @@
 
 include $(top_srcdir)/project.am
+include $(top_srcdir)/main.am
 
 COMMON_FILES = $(top_srcdir)/common/setup.texi
Index: doc/networking/ChangeLog
===================================================================
--- doc/networking/ChangeLog	(revision 6d0a5c0bb9b6cff57ed26cfc50e2914ae6030ab0)
+++ doc/networking/ChangeLog	(revision 816539819aafa1b5325202cf5396764ad416a85d)
@@ -1,2 +1,6 @@
+2002-01-18	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: include main.am, require automake-1.5.
+
 2001-01-17	Joel Sherrill <joel@OARcorp.com>
 
Index: doc/networking/Makefile.am
===================================================================
--- doc/networking/Makefile.am	(revision 6d0a5c0bb9b6cff57ed26cfc50e2914ae6030ab0)
+++ doc/networking/Makefile.am	(revision 816539819aafa1b5325202cf5396764ad416a85d)
@@ -7,9 +7,11 @@
 #
 
-AUTOMAKE_OPTIONS = foreign 1.4
+AUTOMAKE_OPTIONS = foreign 1.5
 
 PROJECT = networking
 EDITION = 1
+
 include $(top_srcdir)/project.am
+include $(top_srcdir)/main.am
 
 BMENU2 += -c
Index: doc/new_chapters/ChangeLog
===================================================================
--- doc/new_chapters/ChangeLog	(revision 6d0a5c0bb9b6cff57ed26cfc50e2914ae6030ab0)
+++ doc/new_chapters/ChangeLog	(revision 816539819aafa1b5325202cf5396764ad416a85d)
@@ -1,2 +1,6 @@
+2002-01-18	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: include main.am, require automake-1.5.
+
 2001-01-17	Joel Sherrill <joel@OARcorp.com>
 
Index: doc/new_chapters/Makefile.am
===================================================================
--- doc/new_chapters/Makefile.am	(revision 6d0a5c0bb9b6cff57ed26cfc50e2914ae6030ab0)
+++ doc/new_chapters/Makefile.am	(revision 816539819aafa1b5325202cf5396764ad416a85d)
@@ -7,5 +7,5 @@
 #
 
-AUTOMAKE_OPTIONS = foreign 1.4
+AUTOMAKE_OPTIONS = foreign 1.5
 
 PROJECT = new_chapters
@@ -13,4 +13,5 @@
 
 include $(top_srcdir)/project.am
+include $(top_srcdir)/main.am
 
 GENERATED_FILES = adminiface.texi confspace.texi dumpcontrol.texi \
Index: doc/porting/ChangeLog
===================================================================
--- doc/porting/ChangeLog	(revision 6d0a5c0bb9b6cff57ed26cfc50e2914ae6030ab0)
+++ doc/porting/ChangeLog	(revision 816539819aafa1b5325202cf5396764ad416a85d)
@@ -1,2 +1,6 @@
+2002-01-18	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: include main.am, require automake-1.5.
+
 2001-01-17	Joel Sherrill <joel@OARcorp.com>
 
Index: doc/porting/Makefile.am
===================================================================
--- doc/porting/Makefile.am	(revision 6d0a5c0bb9b6cff57ed26cfc50e2914ae6030ab0)
+++ doc/porting/Makefile.am	(revision 816539819aafa1b5325202cf5396764ad416a85d)
@@ -7,5 +7,5 @@
 #
 
-AUTOMAKE_OPTIONS = foreign 1.4
+AUTOMAKE_OPTIONS = foreign 1.5
 
 PROJECT = porting
@@ -13,4 +13,5 @@
 
 include $(top_srcdir)/project.am
+include $(top_srcdir)/main.am
 
 FILES = preface.texi developtools.texi sourcecode.texi cpumodels.texi \
Index: doc/posix1003.1/ChangeLog
===================================================================
--- doc/posix1003.1/ChangeLog	(revision 6d0a5c0bb9b6cff57ed26cfc50e2914ae6030ab0)
+++ doc/posix1003.1/ChangeLog	(revision 816539819aafa1b5325202cf5396764ad416a85d)
@@ -1,2 +1,6 @@
+2002-01-18	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: include main.am, require automake-1.5.
+
 2001-01-17	Joel Sherrill <joel@OARcorp.com>
 
Index: doc/posix1003.1/Makefile.am
===================================================================
--- doc/posix1003.1/Makefile.am	(revision 6d0a5c0bb9b6cff57ed26cfc50e2914ae6030ab0)
+++ doc/posix1003.1/Makefile.am	(revision 816539819aafa1b5325202cf5396764ad416a85d)
@@ -7,5 +7,5 @@
 #
 
-AUTOMAKE_OPTIONS = foreign 1.4
+AUTOMAKE_OPTIONS = foreign 1.5
 
 PROJECT = posix1003_1
@@ -13,4 +13,5 @@
 
 include $(top_srcdir)/project.am
+include $(top_srcdir)/main.am
 
 GENERATED_FILES = ch01.texi ch02.texi ch03.texi ch04.texi ch05.texi \
Index: doc/posix_users/ChangeLog
===================================================================
--- doc/posix_users/ChangeLog	(revision 6d0a5c0bb9b6cff57ed26cfc50e2914ae6030ab0)
+++ doc/posix_users/ChangeLog	(revision 816539819aafa1b5325202cf5396764ad416a85d)
@@ -1,2 +1,6 @@
+2002-01-18	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: include main.am, require automake-1.5.
+
 2001-01-17	Joel Sherrill <joel@OARcorp.com>
 
Index: doc/posix_users/Makefile.am
===================================================================
--- doc/posix_users/Makefile.am	(revision 6d0a5c0bb9b6cff57ed26cfc50e2914ae6030ab0)
+++ doc/posix_users/Makefile.am	(revision 816539819aafa1b5325202cf5396764ad416a85d)
@@ -7,5 +7,5 @@
 #
 
-AUTOMAKE_OPTIONS = foreign 1.4
+AUTOMAKE_OPTIONS = foreign 1.5
 
 PROJECT = posix_users
@@ -13,4 +13,5 @@
 
 include $(top_srcdir)/project.am
+include $(top_srcdir)/main.am
 
 GENERATED_FILES = cancel.texi clock.texi cond.texi cspecific.texi \
Index: doc/relnotes/ChangeLog
===================================================================
--- doc/relnotes/ChangeLog	(revision 6d0a5c0bb9b6cff57ed26cfc50e2914ae6030ab0)
+++ doc/relnotes/ChangeLog	(revision 816539819aafa1b5325202cf5396764ad416a85d)
@@ -1,2 +1,6 @@
+2002-01-18	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: include main.am, require automake-1.5.
+
 2001-01-17	Joel Sherrill <joel@OARcorp.com>
 
Index: doc/relnotes/Makefile.am
===================================================================
--- doc/relnotes/Makefile.am	(revision 6d0a5c0bb9b6cff57ed26cfc50e2914ae6030ab0)
+++ doc/relnotes/Makefile.am	(revision 816539819aafa1b5325202cf5396764ad416a85d)
@@ -7,5 +7,5 @@
 #
 
-AUTOMAKE_OPTIONS = foreign 1.4
+AUTOMAKE_OPTIONS = foreign 1.5
 
 PROJECT = relnotes
@@ -13,4 +13,5 @@
 
 include $(top_srcdir)/project.am
+include $(top_srcdir)/main.am
 
 COMMON_FILES = $(top_srcdir)/common/setup.texi \
Index: doc/rgdb_specs/ChangeLog
===================================================================
--- doc/rgdb_specs/ChangeLog	(revision 6d0a5c0bb9b6cff57ed26cfc50e2914ae6030ab0)
+++ doc/rgdb_specs/ChangeLog	(revision 816539819aafa1b5325202cf5396764ad416a85d)
@@ -1,2 +1,6 @@
+2002-01-18	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: include main.am, require automake-1.5.
+
 2001-01-17	Joel Sherrill <joel@OARcorp.com>
 
Index: doc/rgdb_specs/Makefile.am
===================================================================
--- doc/rgdb_specs/Makefile.am	(revision 6d0a5c0bb9b6cff57ed26cfc50e2914ae6030ab0)
+++ doc/rgdb_specs/Makefile.am	(revision 816539819aafa1b5325202cf5396764ad416a85d)
@@ -7,5 +7,5 @@
 #
 
-AUTOMAKE_OPTIONS = foreign 1.4
+AUTOMAKE_OPTIONS = foreign 1.5
 
 PROJECT = rgdb_specs
@@ -13,4 +13,5 @@
 
 include $(top_srcdir)/project.am
+include $(top_srcdir)/main.am
 
 GENERATED_FILES = intro.texi revision.texi objectives.texi gdbinternals.texi \
Index: doc/rtems_gdb/ChangeLog
===================================================================
--- doc/rtems_gdb/ChangeLog	(revision 6d0a5c0bb9b6cff57ed26cfc50e2914ae6030ab0)
+++ doc/rtems_gdb/ChangeLog	(revision 816539819aafa1b5325202cf5396764ad416a85d)
@@ -1,2 +1,6 @@
+2002-01-18	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: include main.am, require automake-1.5.
+
 2001-01-17	Joel Sherrill <joel@OARcorp.com>
 
Index: doc/rtems_gdb/Makefile.am
===================================================================
--- doc/rtems_gdb/Makefile.am	(revision 6d0a5c0bb9b6cff57ed26cfc50e2914ae6030ab0)
+++ doc/rtems_gdb/Makefile.am	(revision 816539819aafa1b5325202cf5396764ad416a85d)
@@ -7,5 +7,5 @@
 #
 
-AUTOMAKE_OPTIONS = foreign 1.4
+AUTOMAKE_OPTIONS = foreign 1.5
 
 PROJECT = rtems_gdb
@@ -13,4 +13,5 @@
 
 include $(top_srcdir)/project.am
+include $(top_srcdir)/main.am
 
 GENERATED_FILES = intro.texi swarch.texi started.texi commands.texi \
Index: doc/started_ada/ChangeLog
===================================================================
--- doc/started_ada/ChangeLog	(revision 6d0a5c0bb9b6cff57ed26cfc50e2914ae6030ab0)
+++ doc/started_ada/ChangeLog	(revision 816539819aafa1b5325202cf5396764ad416a85d)
@@ -1,2 +1,6 @@
+2002-01-18	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: include main.am, require automake-1.5.
+
 2001-01-17	Joel Sherrill <joel@OARcorp.com>
 
Index: doc/started_ada/Makefile.am
===================================================================
--- doc/started_ada/Makefile.am	(revision 6d0a5c0bb9b6cff57ed26cfc50e2914ae6030ab0)
+++ doc/started_ada/Makefile.am	(revision 816539819aafa1b5325202cf5396764ad416a85d)
@@ -7,5 +7,5 @@
 #
 
-AUTOMAKE_OPTIONS = foreign 1.4
+AUTOMAKE_OPTIONS = foreign 1.5
 
 PROJECT = started_ada
@@ -13,4 +13,5 @@
 
 include $(top_srcdir)/project.am
+include $(top_srcdir)/main.am
 
 GENERATED_FILES = buildada.texi buildrt.texi gdb.texi intro.texi \
Index: doc/user/ChangeLog
===================================================================
--- doc/user/ChangeLog	(revision 6d0a5c0bb9b6cff57ed26cfc50e2914ae6030ab0)
+++ doc/user/ChangeLog	(revision 816539819aafa1b5325202cf5396764ad416a85d)
@@ -1,2 +1,6 @@
+2002-01-18	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: include main.am, require automake-1.5.
+
 2001-01-17	Joel Sherrill <joel@OARcorp.com>
 
Index: doc/user/Makefile.am
===================================================================
--- doc/user/Makefile.am	(revision 6d0a5c0bb9b6cff57ed26cfc50e2914ae6030ab0)
+++ doc/user/Makefile.am	(revision 816539819aafa1b5325202cf5396764ad416a85d)
@@ -7,5 +7,5 @@
 #
 
-AUTOMAKE_OPTIONS = foreign 1.4
+AUTOMAKE_OPTIONS = foreign 1.5
 
 PROJECT = c_user
@@ -13,4 +13,5 @@
 
 include $(top_srcdir)/project.am
+include $(top_srcdir)/main.am
 
 FILES = bsp.texi dirstat.texi example.texi glossary.texi preface.texi