Index: cpukit/ChangeLog
===================================================================
--- cpukit/ChangeLog	(revision 64a3101718eefd41c35caf9f43629a9cf4c45d1c)
+++ cpukit/ChangeLog	(revision 843459426b5eb3283932d272351efe94e4697207)
@@ -1,2 +1,8 @@
+2011-05-17	Chris Johns <chrisj@rtems.org>
+
+	PR 1774/filesystem
+	* libfs/src/imfs/imfs_eval.c: The previous change broke some of
+	the tests. This has been fixed.
+	
 2011-05-11	Sebastian Huber <sebastian.huber@embedded-brains.de>
 
Index: cpukit/libfs/src/imfs/imfs_eval.c
===================================================================
--- cpukit/libfs/src/imfs/imfs_eval.c	(revision 64a3101718eefd41c35caf9f43629a9cf4c45d1c)
+++ cpukit/libfs/src/imfs/imfs_eval.c	(revision 843459426b5eb3283932d272351efe94e4697207)
@@ -271,4 +271,20 @@
 }
 
+/*
+ * IMFS_skip_separator
+ *
+ * Skip the separator in the path.
+ */
+static void IMFS_skip_separator (
+   const char *path,       /* IN     */
+   size_t     *len,        /* IN/OUT */
+   int        *index       /* IN/OUT */
+)
+{
+  while ( IMFS_is_separator( path[*index] ) && path[*index] && *len ) {
+    ++(*index);
+    --(*len);
+  }
+}
 
 /*
@@ -282,18 +298,17 @@
 
 int IMFS_evaluate_for_make(
-   const char                         *path,       /* IN     */
-   rtems_filesystem_location_info_t   *pathloc,    /* IN/OUT */
-   const char                        **name        /* OUT    */
-)
+  const char                         *path,       /* IN     */
+  rtems_filesystem_location_info_t   *pathloc,    /* IN/OUT */
+  const char                        **name        /* OUT    */
+                           )
 {
-  int                                 i = 0;
-  int                                 len;
-  IMFS_token_types                    type;
-  char                                token[ IMFS_NAME_MAX + 1 ];
-  rtems_filesystem_location_info_t    newloc;
-  IMFS_jnode_t                       *node;
-  bool                                done = false;
-  int                                 pathlen;
-  int                                 result;
+  int               i = 0;
+  int               len;
+  IMFS_token_types  type;
+  char              token[ IMFS_NAME_MAX + 1 ];
+  IMFS_jnode_t     *node;
+  bool              done = false;
+  size_t            pathlen;
+  int               result;
 
   /*
@@ -347,6 +362,5 @@
         */
 
-        if (pathloc->node_access ==
-            pathloc->mt_entry->mt_fs_root.node_access){
+        if (pathloc->node_access == pathloc->mt_entry->mt_fs_root.node_access){
 
           /*
@@ -356,8 +370,8 @@
           if ( pathloc->node_access == rtems_filesystem_root.node_access ) {
             break;
+
           } else {
-            newloc = pathloc->mt_entry->mt_point_node;
-            *pathloc = newloc;
-            return (*pathloc->ops->evalformake_h)( &path[i], pathloc, name );
+            *pathloc = pathloc->mt_entry->mt_point_node;
+            return (*pathloc->ops->evalformake_h)( &path[i-len], pathloc, name );
           }
         } else {
@@ -402,5 +416,5 @@
 
         /*
-         * Otherwise find the token name in the present location.
+         * Find the token name in the present location.
          */
 
@@ -415,13 +429,15 @@
           done = true;
         else {
-          /*
-           * If we are at a node that is a mount point. Set loc to the
-           * new fs root node and let them finish evaluating the path.
-           */
-
-          if ( node->info.directory.mt_fs != NULL ) {
-            newloc  = node->info.directory.mt_fs->mt_fs_root;
-            *pathloc = newloc;
-            return (*pathloc->ops->evalformake_h)( &path[i], pathloc, name );
+        if (( node->type == IMFS_DIRECTORY ) && ( node->info.directory.mt_fs != NULL )) {
+            IMFS_skip_separator( path, &pathlen, &i);
+            if ((path[i] != '.') || (path[i + 1] != '.')) {
+              *pathloc = node->info.directory.mt_fs->mt_fs_root;
+              return (*pathloc->ops->evalformake_h)( &path[i],
+                                                     pathloc,
+                                                     name );
+            }
+            i += 2;
+            pathlen -= 2;
+            node = node->Parent;
           }
           
@@ -494,11 +510,10 @@
                    )
 {
-  int                                 i = 0;
-  int                                 len;
-  IMFS_token_types                    type = IMFS_CURRENT_DIR;
-  char                                token[ IMFS_NAME_MAX + 1 ];
-  rtems_filesystem_location_info_t    newloc;
-  IMFS_jnode_t                       *node;
-  int                                 result;
+  int               i = 0;
+  int               len;
+  IMFS_token_types  type = IMFS_CURRENT_DIR;
+  char              token[ IMFS_NAME_MAX + 1 ];
+  IMFS_jnode_t     *node;
+  int               result;
 
   if ( !rtems_libio_is_valid_perms( flags ) ) {
@@ -560,8 +575,7 @@
             break;       /* Throw out the .. in this case */
           } else {
-            newloc = pathloc->mt_entry->mt_point_node;
-            *pathloc = newloc;
-            return (*pathloc->ops->evalpath_h)(&(pathname[i]),
-                                               pathnamelen,
+            *pathloc = pathloc->mt_entry->mt_point_node;
+            return (*pathloc->ops->evalpath_h)(&(pathname[i-len]),
+                                               pathnamelen+len,
                                                flags,pathloc);
           }
@@ -606,5 +620,5 @@
 
         /*
-         *  Otherwise find the token name in the present location.
+         *  Find the token name in the current node.
          */
 
@@ -614,4 +628,30 @@
           rtems_set_errno_and_return_minus_one( ENOENT );
 
+        /*
+         *  If we are at a node that is a mount point so current directory
+         *  actually exists on the mounted file system and not in the node that
+         *  contains the mount point node. For example a stat of the mount
+         *  point should return the details of the root of the mounted file
+         *  system not the mount point node of parent file system.
+         *
+         *  If the node we have just moved to is a mount point do not loop and
+         *  get the token because the token may be suitable for the mounted
+         *  file system and not the IMFS. For example the IMFS length is
+         *  limited. If the token is a parent directory move back up otherwise
+         *  set loc to the new fs root node and let them finish evaluating the
+         *  path.
+         */
+        if (( node->type == IMFS_DIRECTORY ) && ( node->info.directory.mt_fs != NULL )) {
+          IMFS_skip_separator( pathname, &pathnamelen, &i);
+          if ((pathname[i] != '.') || (pathname[i + 1] != '.')) {
+            *pathloc = node->info.directory.mt_fs->mt_fs_root;
+            return (*pathloc->ops->evalpath_h)( &pathname[i],
+                                                pathnamelen,
+                                                flags, pathloc );
+          }
+          i += 2;
+          pathnamelen -= 2;
+          node = node->Parent;
+        }
 
         /*
@@ -620,17 +660,4 @@
 
         pathloc->node_access = node;
-        
-        /*
-         *  If we are at a node that is a mount point. Set loc to the
-         *  new fs root node and let them finish evaluating the path.
-         */
-
-        if ( node->info.directory.mt_fs != NULL ) {
-          newloc   = node->info.directory.mt_fs->mt_fs_root;
-          *pathloc = newloc;
-          return (*pathloc->ops->evalpath_h)( &pathname[i],
-                                              pathnamelen,
-                                              flags, pathloc );
-        }
         break;
 
@@ -657,6 +684,5 @@
   if ( node->type == IMFS_DIRECTORY ) {
     if ( node->info.directory.mt_fs != NULL ) {
-      newloc   = node->info.directory.mt_fs->mt_fs_root;
-      *pathloc = newloc;
+      *pathloc = node->info.directory.mt_fs->mt_fs_root;
       return (*pathloc->ops->evalpath_h)( &pathname[i-len],
                                           pathnamelen+len,