Index: c/src/lib/libbsp/sparc/erc32/console/console.c
===================================================================
--- c/src/lib/libbsp/sparc/erc32/console/console.c	(revision f44b66857483fc18c1f6a19f17b07ac55f7f7b75)
+++ c/src/lib/libbsp/sparc/erc32/console/console.c	(revision 864320562db94e546fb0b6e84278cfb80b83219b)
@@ -72,5 +72,5 @@
 
 Ring_buffer_t  TX_Buffer[ 2 ];
-boolean        Is_TX_active[ 2 ];
+bool           Is_TX_active[ 2 ];
 
 void *console_termios_data[ 2 ];
@@ -111,5 +111,5 @@
       ERC32_MEC.UART_Channel_A = (uint32_t) ch;
     } else
-     Is_TX_active[ 0 ] = FALSE;
+     Is_TX_active[ 0 ] = false;
   }
 
@@ -152,5 +152,5 @@
       ERC32_MEC.UART_Channel_B = (uint32_t) ch;
     } else
-     Is_TX_active[ 1 ] = FALSE;
+     Is_TX_active[ 1 ] = false;
   }
 
@@ -229,6 +229,6 @@
   Ring_buffer_Initialize( &TX_Buffer[ 1 ] );
 
-  Is_TX_active[ 0 ] = FALSE;
-  Is_TX_active[ 1 ] = FALSE;
+  Is_TX_active[ 0 ] = false;
+  Is_TX_active[ 1 ] = false;
 
   atexit( console_exit );
@@ -264,6 +264,6 @@
    */
 
-  if ( Is_TX_active[ port ] == FALSE ) {
-    Is_TX_active[ port ] = TRUE;
+  if ( Is_TX_active[ port ] == false ) {
+    Is_TX_active[ port ] = true;
     console_outbyte_polled( port, ch );
     return;
Index: c/src/lib/libbsp/sparc/erc32/timer/timer.c
===================================================================
--- c/src/lib/libbsp/sparc/erc32/timer/timer.c	(revision f44b66857483fc18c1f6a19f17b07ac55f7f7b75)
+++ c/src/lib/libbsp/sparc/erc32/timer/timer.c	(revision 864320562db94e546fb0b6e84278cfb80b83219b)
@@ -25,5 +25,5 @@
 bool benchmark_timer_find_average_overhead;
 
-bool benchmark_timer_is_initialized = FALSE;
+bool benchmark_timer_is_initialized = false;
 
 void benchmark_timer_initialize(void)
@@ -33,5 +33,5 @@
    */
 
-  if ( benchmark_timer_is_initialized == FALSE ) {
+  if ( benchmark_timer_is_initialized == false ) {
 
     /* approximately 1 us per countdown */
@@ -40,5 +40,5 @@
 
   } else {
-    benchmark_timer_is_initialized = TRUE;
+    benchmark_timer_is_initialized = true;
   }
 
@@ -72,5 +72,5 @@
   total = 0xffffffff - total;
 
-  if ( benchmark_timer_find_average_overhead == 1 )
+  if ( benchmark_timer_find_average_overhead == true )
     return total;          /* in one microsecond units */
 
Index: c/src/lib/libbsp/sparc/leon2/console/console.c
===================================================================
--- c/src/lib/libbsp/sparc/leon2/console/console.c	(revision f44b66857483fc18c1f6a19f17b07ac55f7f7b75)
+++ c/src/lib/libbsp/sparc/leon2/console/console.c	(revision 864320562db94e546fb0b6e84278cfb80b83219b)
@@ -73,5 +73,5 @@
  
 Ring_buffer_t  TX_Buffer[ 2 ];
-boolean        Is_TX_active[ 2 ];
+bool           Is_TX_active[ 2 ];
  
 void *console_termios_data[ 2 ];
@@ -111,5 +111,5 @@
       LEON_REG.UART_Channel_1 = (uint32_t) ch;
     } else
-     Is_TX_active[ 0 ] = FALSE;
+     Is_TX_active[ 0 ] = false;
   }
  
@@ -151,5 +151,5 @@
       LEON_REG.UART_Channel_2 = (uint32_t) ch;
     } else
-     Is_TX_active[ 1 ] = FALSE;
+     Is_TX_active[ 1 ] = false;
   }
 
@@ -234,6 +234,6 @@
   Ring_buffer_Initialize( &TX_Buffer[ 1 ] );
 
-  Is_TX_active[ 0 ] = FALSE;
-  Is_TX_active[ 1 ] = FALSE;
+  Is_TX_active[ 0 ] = false;
+  Is_TX_active[ 1 ] = false;
 
   atexit( console_exit );
@@ -272,6 +272,6 @@
    */
 
-  if ( Is_TX_active[ port ] == FALSE ) {
-    Is_TX_active[ port ] = TRUE;
+  if ( Is_TX_active[ port ] == false ) {
+    Is_TX_active[ port ] = true;
     console_outbyte_polled( port, ch );
     return;
Index: c/src/lib/libbsp/sparc/leon2/timer/timer.c
===================================================================
--- c/src/lib/libbsp/sparc/leon2/timer/timer.c	(revision f44b66857483fc18c1f6a19f17b07ac55f7f7b75)
+++ c/src/lib/libbsp/sparc/leon2/timer/timer.c	(revision 864320562db94e546fb0b6e84278cfb80b83219b)
@@ -25,5 +25,5 @@
 bool benchmark_timer_find_average_overhead;
 
-bool benchmark_timer_is_initialized = FALSE;
+bool benchmark_timer_is_initialized = false;
 
 void benchmark_timer_initialize(void)
@@ -33,5 +33,5 @@
    */
 
-  if ( benchmark_timer_is_initialized == FALSE ) {
+  if ( benchmark_timer_is_initialized == false ) {
 
     /* approximately 1 us per countdown */
@@ -40,5 +40,5 @@
 
   } else {
-    benchmark_timer_is_initialized = TRUE;
+    benchmark_timer_is_initialized = true;
   }
 
@@ -62,5 +62,5 @@
   total = 0xffffff - total;
 
-  if ( benchmark_timer_find_average_overhead == 1 )
+  if ( benchmark_timer_find_average_overhead == true )
     return total;          /* in one microsecond units */
 
Index: c/src/lib/libbsp/sparc/leon3/timer/timer.c
===================================================================
--- c/src/lib/libbsp/sparc/leon3/timer/timer.c	(revision f44b66857483fc18c1f6a19f17b07ac55f7f7b75)
+++ c/src/lib/libbsp/sparc/leon3/timer/timer.c	(revision 864320562db94e546fb0b6e84278cfb80b83219b)
@@ -33,5 +33,5 @@
 bool benchmark_timer_find_average_overhead;
 
-bool benchmark_timer_is_initialized = FALSE;
+bool benchmark_timer_is_initialized = false;
 
 extern volatile LEON3_Timer_Regs_Map *LEON3_Timer_Regs;
@@ -43,10 +43,10 @@
    */
   if (LEON3_Timer_Regs) {
-    if ( benchmark_timer_is_initialized == FALSE ) {
+    if ( benchmark_timer_is_initialized == false ) {
       /* approximately 1 us per countdown */
       LEON3_Timer_Regs->timer[LEON3_TIMER_INDEX].reload = 0xffffff;
       LEON3_Timer_Regs->timer[LEON3_TIMER_INDEX].value = 0xffffff;
     } else {
-      benchmark_timer_is_initialized = TRUE;
+      benchmark_timer_is_initialized = true;
     }
     LEON3_Timer_Regs->timer[LEON3_TIMER_INDEX].conf = LEON3_GPTIMER_EN | LEON3_GPTIMER_LD;
@@ -67,5 +67,5 @@
     total = 0xffffff - total;
     
-    if ( benchmark_timer_find_average_overhead == 1 )
+    if ( benchmark_timer_find_average_overhead == true )
       return total;          /* in one microsecond units */
     